        org  32768

MCTRAP: dec  sp
        dec  sp
MODE48: ld   hl,$1b9e        ;LINE-NEW
        bit  4,(iy+$01)
        jr   z,MCCONT
        ld   a,(19)
        inc  a               ;A =168 if +2A/+3 else 0
        ld   d,a
        ld   a,(5440)        ;A =83 if Sinclair else 65 if Amstrad
        add  a,d             ;A =83 +128k; =65 +2; =233 +2A/+3/+3e
        cp   233
        jr   nz,MCCONT
PLUS3M: ld   hl,$1031        ;STMT-RET (+2A/+3/+3e ROM.1)
        push hl
        ld   hl,$5b2f        ;REGNUOY  (+2A/+3/+3e paging)
MCCONT: push hl
        LD   HL,(23621)      ;save PPC current line
        LD   A,(23610)       ;save ERR_NR error code
        LD   (23681),A       ;in "not used"
        LD   A,$ff
        LD   (23610),A       ;reset error code
        LD   HL,9000         ;line number of BASIC error handler
        ld   a,1             ;statement number
        ld   d,a
MCLOOP: CALL $1f54           ;BREAK-KEY
        JP   C,$1e73         ;GO-TO-2 - jump if not BREAK
        JR   MCLOOP          ;ignore BREAK

MODESW: ld   a,(75)
        cp   191
        ret  z               ;16k/48k
        ld   a,(iy+$01)
        bit  4,a
        jr   z,TO_ALL
        ld   hl,($5C4F)      ;(CHANS)
        ld   bc,$0004
        add  hl,bc
        inc  hl              ;HL=channel info for "S"
        ld   de,$000a
        ex   de,hl
        add  hl,de
        ex   de,hl           ;DE=channel info for "P"
        ldir                 ;replace channel info "P" with "S"
TO_ALL: xor  $10
        ld   (iy+$01),a      ;switch "48K BASIC" or "128K BASIC" mode
        ld   sp,($5c3d)      ;ERR_SP
        ld   hl,$0014        ;address of $FF in BASIC ROM, for report "0 OK"
        push hl
        ld   hl,$0008        ;address of ERROR_1
        push hl
        ret
